%Nov 24, 2014: Try this program with data from the MA17E from Nov.14
%clear all;
close all
clc;

%Program to evaluate each of the data sets:
% Here are several TP files from MEEI data set.  One contains a 'perfect'
% probe calibration results.  The other four (a-d) were measured back
% to back on the same day with very similar control results - passed
% but not perfect.  Must be very frustrating.  What is the difference
% (causes) between the perfect and not so perfect?  The problem region for
% not so perfect is in 1.5 to 5 kHz region.  We talked about steel wire.
% I think one of the major issues is with the ear tips.  We can compare
% a brand new tip vs. a repeatedly used tip vs. not well-glued tip.

set(0,'defaultaxeslinewidth',1);
set(0,'DefaultLineLineWidth',2);
set(0,'DefaultAxesFontSize',16);

%load ../Data/lastTPData_Perfect.mat
%load ../mat/4cdata_MA17E_best.mat
load 4cdata_MA17E_best.mat

    Fsamp=sig.SR;
    NFT=sig.N;
    NF=sig.nf;
    Fmax=sig.Fmax;
    Fmin=sig.Fmin;
    F=sig.FrequenciesAll;
    F=F(:); %col vect
        
    Zs=sourceImpedance(:);
    Ps=sourcePressure(:);
        
    Us = Ps(2:end)./Zs(2:end); Us=[0; Us];

F=F/1e3; Fmax=Fmax/1e3; Fmin=Fmin/1e3; %convert to kHz
%df=Fmin;
Pl4ch1=cavityResponse.';

fig(1);
plot(Us);grid;title('MA17E_best')

fig(2);
loglog(F,abs(Pl4ch1(:,4)));hold on
loglog(F,abs(Pl4ch1(:,3)),'r')
loglog(F,abs(Pl4ch1(:,2)),'g')
loglog(F,abs(Pl4ch1(:,1)),'c')
hold off; grid on
xlim([0.1 Fmax]); ylim([.009 3]);
str=sprintf('Cavity Pressures: %s', '4cdata\_MA17E\_best.mat');
title(str);



fig(3);
%subplot(211); %Plot mag and phase of Z2,Z3,Z
%try to cancel the pole in the data
%
% Len4C = [8.501508686114859 11.511088241121172 16.874059935251204 22.288265565356397 ]
%
s=i*2*pi*F; %compute along the j\omega axis
%s3=2*pi*(-0.022*1.999+0.9994*3.809i); %Pretty good ans
s3=2*pi*(-0.022*1.999+0.9994*3.809i); %Gustimate of first complex pole freq
%s4=2*pi*(-0.026+5039i);
%P3=((s+.026).^2)./( (s+s3).*( s+s3.' ) ); %Pole pair

 for df0=.021:0.0005:.024
s3=2*pi*(-df0*1.999+0.9994*3.809i); %Gustimate of first complex pole freq
%s4=2*pi*(-0.026+5039i);
Z2=(s-s3)./s3; %This only includes the 2d quad zero
Z3=(s-s3')./s3'; %This is the 3d quad zero over positive freqs
%Z2=Z2./s;Z3=Z3./s;
Z=Z2.*Z3;
% loglog(F,abs(Z2),'r-', F,abs(Z3),'b--',F,abs(Z),'m');
% hold on
%  end
% grid on;
% ylim([.005 5]); xlim([1 5]);
%title('\color{red}|j\omega-s_+|; \color{blue}|j\omega-s_-|; \color{magenta}(j\omega-s_+)(j\omega-s_-)');
% 
% subplot(212)
% semilogx(F,1+angle(Z2)/pi,'r-', F,1+angle(Z3)/pi,'b--',F,angle(Z)/pi,'.m');grid on;
% xlabel('Freq [kHz]');ylabel('\angle [Rad/pi]')
% 
% [~,k3]=min(abs(imag(s-s3))); %Find index for s3
% kd=50;
% k=k3-kd:k3+kd;
% 
% fig(4);
% 
 R12=[Pl4ch1(:,4)./Pl4ch1(:,1),Pl4ch1(:,3)./Pl4ch1(:,1)];
 R12=1./R12;
% subplot(211)
% %semilogy(F,abs(R12(:,1)),'r', F,abs(1.9./Z),'g' ,F(k),abs(R12(k,1).*Z(k)),'b');
% semilogy(F,abs(R12(:,1)),'r', F,abs(1.9*Z),'g' ,F(k),abs(R12(k,1).*Z(k)),'b');
% grid;
% %ylim([0.5,200]);
% title('r: press C_1; g: Y_1; b: U_1')
% 
% subplot(212)
% plot(F,unwrap(angle(R12(:,1))),F,unwrap(angle(R12(:,1).*Z)),'b');grid
% 
% fig(5);
E=R12(:,1).*Z;

plot(E(k),'k');grid;hold on
plot(E(k3),'mp','MarkerSize',15);
plot(E(k(1:kd)),'og')
plot(E(k(end-kd+1):k(end)),'sr');
pause(1)
 end
 
grid on
hold off
title('green: start frequency; red: stop freq; ')
ylim([0.3 0.5]);
xlim([0.6 0.8]);




